//
//  ViewController.m
//  动画
//
//  Created by soft-angel on 16/3/29.
//  Copyright © 2016年 soft－angel. All rights reserved.
//

#import "ViewController.h"

@interface ViewController ()
{
    UIButton * _btn1;
    UIButton * _btn2;
    UIButton * _btn3;
    CGRect  _frame;
    NSMutableArray * _array;
}


@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view, typically from a nib.
    _array  = [[NSMutableArray alloc]initWithCapacity:0];
    _btn1 = [[UIButton alloc]initWithFrame:CGRectMake(30, 120, 40, 40)];
    _btn2 = [[UIButton alloc]initWithFrame:CGRectMake(120, 100, 80, 80)];
    _btn3 = [[UIButton alloc]initWithFrame:CGRectMake(250, 120, 40, 40)];
    _frame = _btn2.frame;
    [_btn1 addTarget:self action:@selector(btn1Click:) forControlEvents:UIControlEventTouchUpInside];
    [_btn2 addTarget:self action:@selector(btn2Click:) forControlEvents:UIControlEventTouchUpInside];
    [_btn3 addTarget:self action:@selector(btn3Click:) forControlEvents:UIControlEventTouchUpInside];
    [_btn1 setBackgroundImage:[UIImage imageNamed:@"iconfont-yaochi.png"] forState:UIControlStateNormal];
    [_btn2 setBackgroundImage:[UIImage imageNamed:@"iconfont-fangwu.png"] forState:UIControlStateNormal];
    [_btn3 setBackgroundImage:[UIImage imageNamed:@"iconfont-3.png"] forState:UIControlStateNormal];
    
    UISwipeGestureRecognizer * swipe1 = [[UISwipeGestureRecognizer alloc]initWithTarget:self action:@selector(gesture:)];
    [swipe1 setDirection:UISwipeGestureRecognizerDirectionLeft];
    UISwipeGestureRecognizer * swipe2 = [[UISwipeGestureRecognizer alloc]initWithTarget:self action:@selector(gesture:)];
    [swipe2 setDirection:UISwipeGestureRecognizerDirectionRight];
    
    UISwipeGestureRecognizer * swipe3 = [[UISwipeGestureRecognizer alloc]initWithTarget:self action:@selector(gesture:)];
    [swipe3 setDirection:UISwipeGestureRecognizerDirectionLeft];
    UISwipeGestureRecognizer * swipe4 = [[UISwipeGestureRecognizer alloc]initWithTarget:self action:@selector(gesture:)];
    [swipe4 setDirection:UISwipeGestureRecognizerDirectionRight];
    
    UISwipeGestureRecognizer * swipe5 = [[UISwipeGestureRecognizer alloc]initWithTarget:self action:@selector(gesture:)];
    [swipe5 setDirection:UISwipeGestureRecognizerDirectionLeft];
    UISwipeGestureRecognizer * swipe6 = [[UISwipeGestureRecognizer alloc]initWithTarget:self action:@selector(gesture:)];
    [swipe6 setDirection:UISwipeGestureRecognizerDirectionRight];
    
    [_btn1 addGestureRecognizer:swipe1];
    [_btn1 addGestureRecognizer:swipe2];
    
    [_btn2 addGestureRecognizer:swipe3];
    [_btn2 addGestureRecognizer:swipe4];
    
    [_btn3 addGestureRecognizer:swipe5];
    [_btn3 addGestureRecognizer:swipe6];
    
    [_array addObject:_btn1];
    [_array addObject:_btn2];
    [_array addObject:_btn3];
    [self.view addSubview:_btn1];
    [self.view addSubview:_btn2];
    [self.view addSubview:_btn3];
}

-(void)gesture:(UISwipeGestureRecognizer *)gesture
{
    if (gesture.view.frame.origin.x == _frame.origin.x)
    {
        if (gesture.direction == UISwipeGestureRecognizerDirectionLeft)
        {
            NSLog(@"中间按钮左滑无效");
        }
        else if (gesture.direction == UISwipeGestureRecognizerDirectionRight)
        {
             NSLog(@"中间按钮右滑无效");
        }
    }
    else if (gesture.view.frame.origin.x < _frame.origin.x)
    {
        if (gesture.direction == UISwipeGestureRecognizerDirectionLeft)
        {
             NSLog(@"左边按钮左滑无效");
        }
        else if (gesture.direction == UISwipeGestureRecognizerDirectionRight)
        {
            [UIView beginAnimations:nil context:nil];
            [UIView setAnimationDelay:0.1f];
            [UIView setAnimationCurve:7];
            [_array enumerateObjectsUsingBlock:^(UIButton * btn, NSUInteger idx, BOOL * _Nonnull stop) {
                if (btn.frame.origin.x == _frame.origin.x)
                {
                    btn.frame = gesture.view.frame;
                }
            }];
            gesture.view.frame = _frame;
            [UIView commitAnimations];
        }

    }
    else if(gesture.view.frame.origin.x > _frame.origin.x)
    {
        if (gesture.direction == UISwipeGestureRecognizerDirectionLeft)
        {
            [UIView beginAnimations:nil context:nil];
            [UIView setAnimationDelay:0.1f];
            [UIView setAnimationCurve:7];
            [_array enumerateObjectsUsingBlock:^(UIButton * btn, NSUInteger idx, BOOL * _Nonnull stop) {
                if (btn.frame.origin.x == _frame.origin.x)
                {
                    btn.frame = gesture.view.frame;
                }
            }];
            gesture.view.frame = _frame;
            [UIView commitAnimations];
        }
        else if (gesture.direction == UISwipeGestureRecognizerDirectionRight)
        {
             NSLog(@"右边按钮右滑无效");
        }
        
    }


}


-(void)btn1Click:(UIButton *)sender
{
    NSLog(@"11111");
    
}

-(void)btn2Click:(UIButton *)sender
{
    NSLog(@"22222");
    
}

-(void)btn3Click:(UIButton *)sender
{
    NSLog(@"33333");
        
}


- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

@end
